/* $Id: concordance.h 213759 2018-02-27 03:38:56Z twu $ */
#ifndef CONCORDANCE_INCLUDED
#define CONCORDANCE_INCLUDED
#ifdef HAVE_CONFIG_H
#include <config.h>		/* For HAVE_64_BIT */
#endif

#include "bool.h"
#include "list.h"
#include "types.h"
#include "genomicpos.h"
#include "ladder.h"
#include "stage3hr.h"
#ifdef LARGE_GENOMES
#include "merge-heap-records.h"
#else
#include "merge-simd-records.h"
#endif

#define T Stage3end_T


extern List_T
Concordance_pair_up_transcriptome (bool *abort_pairing_p, int *concordant_score, List_T hitpairs,

				   Ladder_T ladder5_plus, Ladder_T ladder5_minus,
				   Ladder_T ladder3_plus, Ladder_T ladder3_minus,

				   int maxpairedpaths, int genestrand);

extern List_T
Concordance_pair_up_genome (bool *abort_pairing_p, int *adjacent_score, int *concordant_score, List_T hitpairs,

			    List_T hitlist5_gplus, List_T hitlist5_gminus,
			    List_T hitlist3_gplus, List_T hitlist3_gminus,
			    
			    Ladder_T ladder5_plus, Ladder_T ladder5_minus,
			    Ladder_T ladder3_plus, Ladder_T ladder3_minus,

			    int querylength5, int querylength3, int maxpairedpaths, int genestrand);

extern List_T
Concordance_pair_up_distant (bool *abort_pairing_p, int *concordant_score,
			     List_T *samechr, List_T *conc_transloc, List_T hitpairs, 

			     List_T hitlist5_gplus, List_T hitlist5_gminus,
			     List_T hitlist3_gplus, List_T hitlist3_gminus,

			     Ladder_T ladder5_plus, Ladder_T ladder5_minus,
			     Ladder_T ladder3_plus, Ladder_T ladder3_minus,

			     int querylength5, int querylength3, int maxpairedpaths, int genestrand);

extern int
Concordance_filter_records5 (Intlist_T *plus_anchors, Intlist_T *minus_anchors, int score_start,
			     Record_T *records5_plus, int *candidates5_plus, int ncandidates5_plus,
			     Record_T *records5_minus, int *candidates5_minus, int ncandidates5_minus,
			     Ladder_T ladder3_plus, Ladder_T ladder3_minus,
			     int querylength5, int querylength3);
extern int
Concordance_filter_records3 (Intlist_T *plus_anchors, Intlist_T *minus_anchors, int score_start,
			     Record_T *records3_plus, int *candidates3_plus, int ncandidates3_plus,
			     Record_T *records3_minus, int *candidates3_minus, int ncandidates3_minus,
			     Ladder_T ladder5_plus, Ladder_T ladder5_minus,
			     int querylength5, int querylength3);

extern List_T
Concordance_filter_paths_low (List_T *remainder, List_T pathlist, List_T hitlist, int querylength_paths, int querylength_hits);
extern List_T
Concordance_filter_paths_high (List_T *remainder, List_T pathlist, List_T hitlist, int querylength_paths, int querylength_hits);

extern void
Concordance_setup (int subopt_levels_in, bool novelsplicingp_in,
		   Chrpos_T pairmax_transcriptome_in,
		   Chrpos_T pairmax_linear_in, Chrpos_T pairmax_circular_in,
		   Chrpos_T expected_pairlength_in, Chrpos_T pairlength_deviation_in, 
		   bool *circularp_in, bool merge_samechr_p_in);

#undef T
#endif

