/* $Id: extension-search.h 214305 2018-03-19 23:40:43Z twu $ */
#ifndef EXTENSION_SEARCH_INCLUDED
#define EXTENSION_SEARCH_INCLUDED

#include "types.h"
#include "mode.h"
#include "list.h"

#include "iit-read-univ.h"
#include "genome.h"
#include "splicetrie.h"
#include "compress.h"

#include "stage1hr.h"
#include "indexdb.h"


#define T Elt_T
typedef struct T *T;
struct T {
  int querystart;
  int queryend;

  int nmatches;

  Univcoord_T *all_diagonals;
  int n_all_diagonals;

  Univcoord_T *diagonals;
  int ndiagonals;

  int lowi;
  int highi;
};


extern void
Extension_search_setup (Mode_T mode, Univ_IIT_T chromosome_iit_in, int circular_typeint_in, bool *circularp_in,
			Genome_T genomebits_in, Genome_T genomebits_alt_in, Indexdb_T indexdb_in, Indexdb_T indexdb2_in,
			Chrpos_T shortsplicedist_in, Chrpos_T shortsplicedist_novelend,
			int min_intronlength_in, int max_deletionlength, int max_end_deletions_in,
			int max_middle_insertions_in, int max_end_insertions,
			int index1part_in, int local1part_in);

extern void
Elt_gc (List_T *set);

extern void
Extension_search (int *found_score, List_T *hits_gplus, List_T *hits_gminus,

		  /* Used by Distant_rna_solve */
		  List_T *queryfwd_plus_set, List_T *queryfwd_minus_set,
		  List_T *queryrev_plus_set, List_T *queryrev_minus_set,

		  Stage1_T stage1, char *queryuc_ptr, char *queryrc, int querylength,
		  Compress_T query_compress_fwd, Compress_T query_compress_rev, 

		  Pairpool_T pairpool, Dynprog_T dynprogL, Dynprog_T dynprogM, Dynprog_T dynprogR,
		  Oligoindex_array_T oligoindices_minor, Diagpool_T diagpool, Cellpool_T cellpool,

		  int nmismatches_allowed, int genestrand, bool paired_end_p, int level);

#undef T
#endif


