/* $Id: ladder.h 214025 2018-03-05 07:06:43Z twu $ */
#ifndef LADDER_INCLUDED
#define LADDER_INCLUDED

#include "bool.h"
#include "list.h"
#include "stage3hr.h"

#define T Ladder_T
typedef struct T *T;

extern int
Ladder_maxscore (T this);
extern int
Ladder_cutoff (T this);
extern Stage3end_T *
Ladder_hits_for_score (int *nhits, T this, int score);
extern int *
Ladder_nhits (T this);
extern List_T
Ladder_hitlist (T this, List_T hitlist);
extern void
Ladder_gc_hits (T this);
extern int
Ladder_minimax_trim (T ladder_plus, T ladder_minus, int querylength);

extern void
Ladder_free (T *old);
extern void
Ladder_gc_duplicates (T this);
extern T
Ladder_new (List_T hitlist, bool end5p);

extern void
Ladder_merge (T dest, T source);

#undef T
#endif
