/* $Id: merge-uint4.h 213653 2018-02-23 00:13:01Z twu $ */
#ifndef MERGE_UINT4_INCLUDED
#define MERGE_UINT4_INCLUDED
#ifdef HAVE_CONFIG_H
#include <config.h>		/* For HAVE_64_BIT */
#endif

/* Pad lengths at end for row-based storage */
#ifdef HAVE_AVX512
#define PAD_UINT4(x) (((x + 15)/16) * 16)
#elif defined(HAVE_AVX2)
#define PAD_UINT4(x) (((x + 7)/8) * 8)
#elif defined(HAVE_SSE4_1)
#define PAD_UINT4(x) (((x + 3)/4) * 4)
#else
#define PAD_UINT4(x) (x)
#endif


extern unsigned int *
Merge_uint4 (unsigned int *__restrict__ dest, unsigned int *__restrict__ A,
	     unsigned int *__restrict__ B, int nA, int nB);

#endif


