/* $Id: method.h 213759 2018-02-27 03:38:56Z twu $ */
#ifndef METHOD_INCLUDED
#define METHOD_INCLUDED

#include "filestring.h"


typedef enum {TR, /* tr, from Kmer_search_transcriptome_{single|paired} */
	      KMER_EXACT, /* both ends, from Kmer_search_genome_ends_exact */
	      KMER_APPROX, /* both ends, from Kmer_search_genome_ends_approx */
	      EXT, /* ext, from Extension_search */
	      EXT_GMAP, /* ext-gmap, from Extension_search */
	      SEGMENT, /* seg, from Segment_search_genome */
	      DISTANT, /* distant, from Distant_rna_solve */
	      TERMINAL, /* term, from Terminal_solve */

	      /* The rest are not currently used */
	      KMER_ONE_END, /* one end, from Kmer_search_genome_one_end */
	      KMER_MIDDLE, /* middle, from Kmer_search_genome_one_kmer */
	      SEGMENT_GMAP, /* seg-gmap, from Path_solve_via_gmap */
	      KMER, /* kmer, from Kmer_search_genome_complete (not currently used) */
	      KMER_GMAP, /* kmer-gmap, from Path_solve_via_gmap (not currently used from KMER) */
	      REGION_GMAP /* not yet implemented */} Method_T;

extern char *
Method_string (Method_T method);
extern void
Method_samprint (Filestring_T fp, Method_T method);
extern void
Method_print (Filestring_T fp, Method_T method);

#endif

