/* $Id: path-solve.h 214305 2018-03-19 23:40:43Z twu $ */
#ifndef PATH_INCLUDED
#define PATH_INCLUDED

#include "types.h"
#include "bool.h"
#include "list.h"
#include "univdiag.h"
#include "chrnum.h"
#include "compress.h"
#include "genome.h"
#include "splicetrie.h"
#include "localdb.h"
#include "stage3hr.h"


#if 0
/* Without localdb */
extern List_T
Path_solve_from_diagonals (bool *foundp, int *found_score, List_T *complete_path, List_T hits,
			   List_T middle_path, List_T right_diagonals, List_T left_diagonals,
			   Compress_T query_compress, int querylength, Genome_T genomebits,
			   Chrnum_T chrnum, Univcoord_T chroffset, Univcoord_T chrhigh, Chrpos_T chrlength,
			   bool plusp, int genestrand, int nmismatches_allowed, bool paired_end_p,
			   Method_T method, int level);
#endif


/* Used by kmer-search, extension-search, and segment-search */
extern List_T
Path_solve_from_diagonals (bool *foundp, int *found_score, List_T *complete_path, List_T hits,
			   Univdiag_T middle_diagonal, List_T right_diagonals, List_T left_diagonals,
			   char *queryptr, int querylength, Compress_T query_compress, 
			   Chrnum_T chrnum, Univcoord_T chroffset, Univcoord_T chrhigh, Chrpos_T chrlength,
			   bool plusp, int genestrand, int nmismatches_allowed, bool paired_end_p,
			   Method_T method, int level);


#if 0
/* Used previously by segment-search.c */
List_T
Path_solve_from_path (bool *foundp, int *found_score, List_T hits, List_T complete_path,
		      Compress_T query_compress, int querylength, Genome_T genomebits,
		      Chrnum_T chrnum, Univcoord_T chroffset, Univcoord_T chrhigh, Chrpos_T chrlength,
		      bool plusp, int genestrand, int max_mismatches_allowed, Method_T method, int level);
#endif


extern void
Path_solve_via_gmap (int *found_score, List_T *hits_gplus, List_T *hits_gminus,
		     List_T plus_complete_paths, List_T minus_complete_paths, int genestrand,
		     char *queryuc_ptr, int querylength, Compress_T query_compress_fwd, Compress_T query_compress_rev,
		     Pairpool_T pairpool, Dynprog_T dynprogL, Dynprog_T dynprogM, Dynprog_T dynprogR,
		     Oligoindex_array_T oligoindices_minor, Diagpool_T diagpool, Cellpool_T cellpool,
		     bool paired_end_p, Method_T method, int level);

extern void
Path_solve_setup (Genome_T genomebits_in, Genome_T genomebits_alt_in, bool *circularp_in,
		  Localdb_T localdb_in, Localdb_T localdb2_in,
		  Chrpos_T shortsplicedist_novelend, int min_intronlength_in, int max_deletionlength,
		  int max_insertionlen_in, 
		  bool novelsplicingp_in, Univcoord_T *splicesites_in, Splicetype_T *splicetypes_in,
		  Chrpos_T *splicedists_in, int nsplicesites_in, 
		  Univ_IIT_T chromosome_iit_in, int circular_typeint_in,
		  int index1part_in, int index1interval_in, int local1part_in, int gmap_mode_in,
		  int maxpeelback_in);

#endif

