/* $Id: distant-rna.h 214025 2018-03-05 07:06:43Z twu $ */
#ifndef DISTANT_RNA_INCLUDED
#define DISTANT_RNA_INCLUDED

#include "bool.h"
#include "list.h"
#include "univdiag.h"
#include "compress.h"
#include "genome.h"
#include "iit-read-univ.h"


extern void
Distant_rna_solve (int *found_score, List_T *hits_plus, List_T *hits_minus,

		   List_T queryfwd_plus_set, List_T queryfwd_minus_set,
		   List_T queryrev_plus_set, List_T queryrev_minus_set,

		   Compress_T query_compress_fwd, Compress_T query_compress_rev,
		   int querylength, int user_maxlevel, int max_splice_mismatches,
		   int genestrand, bool first_read_p, int level);

extern void
Distant_rna_setup (Univ_IIT_T chromosome_iit_in, int circular_typeint_in,
		   Genome_T genomebits_in, Genome_T genomebits_alt_in,
		   int index1part_in, int index1interval_in,
		   int subopt_levels_in, Chrpos_T shortsplicedist_in,
		   int min_distantsplicing_end_matches_in, int min_distantsplicing_identity_in,
		   int localsplicing_penalty_in, int distantsplicing_penalty_in);

#endif

